//+------------------------------------------------------------------+
//|                                                       eclock.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      ""

//
//
//
//
//

extern bool   ShowClock              = true;
extern bool   ShowOnFixedPostition   = false;
extern int    cornerForFixedPosition = 3;
extern int    xposForFixedPosition   = 200;
extern int    yposForFixedPosition   = 10;
extern int    windowForFixedPosition = 1;
extern color  colorNormal            = Gold;
extern color  colorLate              = Red;
extern int    fontSize               = 10;
extern string AlertCandleTF          = "";
extern int    AlertCandleCorner      =  3;
extern int    AlertCandleShift       = 10;
extern bool   alertsOn               = false;
extern bool   alertsMessage          = true;
extern bool   alertsSound            = false;
extern bool   alertsEmail            = false;

//
//
//
//
//

int      timeFrame;
bool     AlertsOn;
bool     SetingUp;
string   WatchingTimeFrame;
datetime SavedTime;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SavedTime = EMPTY_VALUE;
   AlertsOn  = false;
   SetingUp  = false;
   timeFrame = stringToTimeFrame(AlertCandleTF);
      if (timeFrame != 0)
         {
            AlertsOn = alertsOn;
            WatchingTimeFrame = TimeFrameToString(timeFrame)+" bar will expire in ";
         }
   
   //
   //
   //
   //
   //
   
   datetime time;
   while(true)
   {  
      ShowClock(); Sleep(500);
      if (IsStopped()) { break; }
   }
   
   
   //
   //
   //
   //
   //
   
   return(0);
}

//
//
//
//
//

int deinit()
{
   switch(UninitializeReason())
   {
      case REASON_CHARTCLOSE:
      case REASON_REMOVE:
               break;
      case REASON_RECOMPILE:
      case REASON_CHARTCHANGE:
      case REASON_PARAMETERS:
      case REASON_ACCOUNT:
               SavedTime = EMPTY_VALUE;
               break;
   }
   ObjectDelete("eclock");
   ObjectDelete("eclocka");
   return(0);
}

//
//
//
//
//

int start()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void ShowClock()
{
   datetime TimeArray[];
   int    theColor;
   string time;
 
   RefreshRates();

   //
   //
   //
   //

   int diff = MathRound((TimeCurrent()-TimeLocal())/3600.0)*3600;
   if (ShowClock)
   {
         time = getTime(iTime(NULL,0,0)+Period()*60-TimeLocal()-diff,theColor);

         //
         //
         //
         //
         //
                  
         if(ObjectFind("eclock") != 0)
            if (ShowOnFixedPostition)
                  ObjectCreate("eclock",OBJ_LABEL,windowForFixedPosition,0,0);
            else  ObjectCreate("eclock",OBJ_TEXT ,0                     ,0,0);
            ObjectSetText("eclock","                                 "+time,fontSize, "Arial bold", theColor);
            double ShiftUp = iATR(NULL,0,25,0)/2.00;
            if (!ShowOnFixedPostition)
                  ObjectMove("eclock", 0,Time[0],Ask+ShiftUp);
            else
            {
               ObjectSet("eclock",OBJPROP_CORNER   ,cornerForFixedPosition);
               ObjectSet("eclock",OBJPROP_XDISTANCE,xposForFixedPosition);
               ObjectSet("eclock",OBJPROP_YDISTANCE,yposForFixedPosition);
            }             
   }
   if (AlertsOn  || (timeFrame!=0 && timeFrame!=Period()))            
   {
         time = getTime(iTime(NULL,timeFrame,0)+timeFrame*60-TimeCurrent(),theColor);
         
         //
         //
         //
         //
         //
         
         if(ObjectFind("eclocka") != 0) {
            ObjectCreate("eclocka",OBJ_LABEL,0,0,0);
            ObjectSet("eclocka",OBJPROP_XDISTANCE,10);
            ObjectSet("eclocka",OBJPROP_YDISTANCE,AlertCandleShift);
            ObjectSet("eclocka",OBJPROP_CORNER,AlertCandleCorner); }
            ObjectSetText("eclocka",WatchingTimeFrame+time,fontSize, "Arial bold", theColor);

            //
            //
            //
            //
            //
            
            if (SavedTime != EMPTY_VALUE)
            if (SavedTime != iTime(NULL,timeFrame,0) && alertsOn) doAlert();
                SavedTime  = iTime(NULL,timeFrame,0);
   }
   WindowRedraw();
}

//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
//
//
//
//
//

string getTime(int times,int& theColor)
{
   string time = "";
   int    seconds;
   int    minutes;
   int    hours;
   
   //
   //
   //
   //
   //
   
   if (times < 0) {
         theColor = colorLate; times = MathAbs(times);}
   else  theColor = colorNormal;
   seconds = (times%60);
   hours   = (times-times%3600)/3600;
   minutes = (times-seconds)/60-hours*60;

   //
   //
   //
   //
   //
   
   if (hours>0)
   if (minutes < 10)
         time = StringConcatenate(time,hours,":0");
   else  time = StringConcatenate(time,hours,":");
         time = StringConcatenate(time,minutes);
   if (seconds < 10)
         time = StringConcatenate(time,":0",seconds);
   else  time = StringConcatenate(time,":" ,seconds);
   return(time);
}

//
//
//
//
//

void doAlert()
{
   string doWhat = TimeFrameToString(timeFrame)+" bar expired";
   string message;
   
   message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ",doWhat);
      if (alertsMessage) Alert(message);
      if (alertsEmail)   SendMail(StringConcatenate(Symbol()," alert"),message);
      if (alertsSound)   PlaySound("alert2.wav");
}

//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   int tf=0;
       tfs = StringUpperCase(tfs);
         if (tfs=="M1" || tfs=="1")     tf=PERIOD_M1;
         if (tfs=="M5" || tfs=="5")     tf=PERIOD_M5;
         if (tfs=="M15"|| tfs=="15")    tf=PERIOD_M15;
         if (tfs=="M30"|| tfs=="30")    tf=PERIOD_M30;
         if (tfs=="H1" || tfs=="60")    tf=PERIOD_H1;
         if (tfs=="H4" || tfs=="240")   tf=PERIOD_H4;
         if (tfs=="D1" || tfs=="1440")  tf=PERIOD_D1;
         if (tfs=="W1" || tfs=="10080") tf=PERIOD_W1;
         if (tfs=="MN" || tfs=="43200") tf=PERIOD_MN1;
  return(tf);
}
string TimeFrameToString(int tf)
{
   string tfs="Current time frame";
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN1";
   }
   return(tfs);
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;
   int      lenght = StringLen(str) - 1;
   int      char;
   
   while(lenght >= 0)
      {
         char = StringGetChar(s, lenght);
         
         //
         //
         //
         //
         //
         
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                  s = StringSetChar(s, lenght, char - 32);
         else 
              if(char > -33 && char < 0)
                  s = StringSetChar(s, lenght, char + 224);
         lenght--;
   }
   
   //
   //
   //
   //
   //
   
   return(s);
}